#!/usr/bin/env groovy
import java.util.Date
import groovy.json.*
def registryHost = "registry.gitlab.com"
def projectRegistry = "registry.gitlab.com/tm30/microservices/gateways/api-gateway";
def projectName = 'wheeler-api-gateway'
def isMaster = env.gitlabSourceBranch == 'master'
def isStaging = env.BRANCH_NAME == 'master'
def start = new Date()
def err = null
def jobInfo = "${env.JOB_NAME} ${env.BUILD_DISPLAY_NAME} \n${env.BUILD_URL}"
def imageTag = "latest";
String jobInfoShort = "${env.JOB_NAME} ${env.BUILD_DISPLAY_NAME}"
String buildStatus
String timeSpent
currentBuild.result = "SUCCESS"
try {
    node {
        deleteDir()
        stage('initializing'){
            slackSend (color: 'good', message: "Initializing build process for `${projectName}` triggered by a push from `${env.gitlabUserName} ...")
        }
        stage ('Checkout') {
            checkout scm
        }
        stage ('Push Docker to Registry') {
            sh "docker login registry.gitlab.com -u BlackHades -p ThawingForest123"
            sh "docker build -t ${projectRegistry}:${env.gitlabSourceBranch}-${imageTag} ."
            sh "docker push ${projectRegistry}:${env.gitlabSourceBranch}-${imageTag}"
//             pushImage(repoName, projectName, imageTag)
            slackSend (color: 'good', message: "docker image on `${env.gitlabSourceBranch}` branch in `${projectName}` pushed to *Gitlab Registry* (${projectRegistry})")
        }
//         stage('Clean up'){
//           sh "docker rmi ${projectRegistry}:${imageTag}"
//         }
    }
} catch (caughtError) {
    err = caughtError
    currentBuild.result = "FAILURE"
} finally {
     timeSpent = "\nTime spent: ${timeDiff(start)}"
     echo timeSpent
    if (err) {
//         sh "echo ${err}"
        slackSend (color: 'danger', message: ":disappointed: _Build failed_: ${jobInfo} ${timeSpent} ${err}")
    } else {
        if (currentBuild.previousBuild == null) {
            buildStatus = '_First time build_'
        } else if (currentBuild.previousBuild.result == 'SUCCESS') {
            buildStatus = '_Build complete_'
        } else {
            buildStatus = '_Back to normal_'
        }
        slackSend (color: 'good', message: "${jobInfo}: ${timeSpent}")
//         sh "echo good"
    }
}
def timeDiff(st) {
    def delta = (new Date()).getTime() - st.getTime()
    def seconds = delta.intdiv(1000) % 60
    def minutes = delta.intdiv(60 * 1000) % 60
    return "${minutes} min ${seconds} sec"
}
